#include "boolballview.h"
#include "graphics.h"

G_DEFINE_TYPE(BoolballView, boolball_view, BOARD_VIEW_TYPE);

static void	_boolball_draw_cell	(BoardView *view, gint x, gint y, gint width, gint height, gint celltype);

void
boolball_view_init(BoolballView *view)
{

}

void
boolball_view_class_init(BoolballViewClass *klass)
{
	BoardViewClass *parentklass = BOARD_VIEW_CLASS(klass);
	parentklass->draw_cell = _boolball_draw_cell;
}

BoolballView *
boolball_view_new()
{
	BoolballView *v = BOOLBALL_VIEW(g_object_new(BOOLBALL_VIEW_TYPE, NULL));
	return v;
}

static void
_boolball_draw_cell(BoardView *view, gint x, gint y, gint width, gint height, gint celltype)
{
	GdkPixbuf *contents;
	board_view_draw_empty_cell(view, x, y, width, height);

	if (celltype == CELL_EMPTY)
		return;

	contents = graphics_get_for_cell(celltype);
	gdk_draw_pixbuf(GTK_WIDGET(view)->window, NULL, contents,
			0, 0, x, y, width, height, 
			GDK_RGB_DITHER_NORMAL, 0, 0);
}

