/* Copyright (c) 2003 Theo van Klaveren, All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: game.h,v 1.4 2005/04/06 10:20:48 klaveren Exp $
 */
#ifndef _GAME_H_
#define _GAME_H_

#include "boolballmodel.h"
#include "player.h"
#include "move.h"

typedef struct {
	/* Playing field */
	BoolballModel	*model;

	/* The players */
	Player		*player_red;
	Player		*player_blue;

	/* Player whose turn it is */
	Player		*player;
	gint		 player_pos;

	/*
	 * The game is like one *giant* state machine. I couldn't think
	 * of any better way to do this. Perhaps make this a real state
	 * machine, instead of a set of booleans?
	 */

	/* Ball move state */
	Movestate	*state;
	gboolean	 falling;

	/* General state */
	gboolean	 playing;
	gboolean	 moving;
	gboolean	 finishing;
} Game;

Game		*game_new(BoolballModel *model);
void		 game_destroy(Game *g);

void		 game_switch_turns(Game *g);

#endif

