/* Copyright (c) 2003 Theo van Klaveren, All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: move.h,v 1.4 2005/04/06 10:20:48 klaveren Exp $
 */
#ifndef _MOVE_H_
#define _MOVE_H_

#include "boolballmodel.h"

typedef struct _Movestate {
	/* Use these to determine what happened in the past move */
	gboolean	 hit_teleporter;
	gboolean	 hit_bonus;
	gboolean	 hit_gray_block;
	gboolean	 hit_bottom;
	gboolean	 left_teleporter;

	/* Other state stuff */
	gboolean	 teleported;
	gboolean	 roll_left;
	gboolean	 roll_right;

	/* Ball position and score so far */
	gint		 fall_x;
	gint		 fall_y;
	gint		 score;
} Movestate;

Movestate	*movestate_new(void);
void		 movestate_destroy(Movestate *ms);

gboolean	 movestate_move(Movestate *ms, BoolballModel *model);

#endif

