/* Copyright (c) 2003 Theo van Klaveren, All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: player.h,v 1.5 2005/04/06 10:20:48 klaveren Exp $
 */
#ifndef _PLAYER_H_
#define _PLAYER_H_

#include "boolballmodel.h"

typedef enum {
	PC_BLUE,
	PC_RED
} PlayerColor;

typedef struct {
	PlayerColor	 color;
	gint		 score;
	guchar		*balls;	/* Remaining balls, array of CellType */
	gboolean	 finished;
} Player;

Player		*player_new(int width, PlayerColor color);
void		 player_destroy(Player *player);

gint		 player_get_ball_color(Player *player);
gboolean	 player_can_move(Player *player, BoolballModel *model);
gboolean	 player_can_drop_ball(Player *player,
				      BoolballModel *model,
				      gint ball_x);
int		 player_count_blocked_balls(Player *player, BoolballModel *model);

#endif

