/* Copyright (c) 2003 Theo van Klaveren, All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: prefs.h,v 1.4 2005/04/06 20:12:11 klaveren Exp $
 */
#ifndef _PREFS_H_
#define _PREFS_H_

#include "ai.h"

#define GCONF_APP_DIR		"/apps/boolball"
#define GCONF_KEY_AI_LEVEL	GCONF_APP_DIR "/ai_level"
#define GCONF_KEY_BOARD_SIZE	GCONF_APP_DIR "/board_size"
#define GCONF_KEY_WINDOW_WIDTH	GCONF_APP_DIR "/window_width"
#define GCONF_KEY_WINDOW_HEIGHT	GCONF_APP_DIR "/window_height"

typedef struct _Prefs Prefs;

Prefs	*prefs_new(void);
void	 prefs_destroy(Prefs *p);

void	 prefs_show(Prefs *p);

gint		prefs_get_field_size(Prefs *p);
AiLevel		prefs_get_ai_level(Prefs *p);

gboolean	prefs_get_window_size(Prefs *p, gint *w, gint *h);
void		prefs_set_window_size(Prefs *p, gint w, gint h);

#endif

