/* Copyright (c) 2003 Theo van Klaveren, All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: scorebox.h,v 1.2 2004/04/27 09:30:09 klaveren Exp $
 */
#ifndef _SCOREBOX_H_
#define _SCOREBOX_H_

#include "player.h"

#define SCOREBOX_TYPE		(scorebox_get_type())
#define SCOREBOX(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), SCOREBOX_TYPE, ScoreBox))

typedef struct _ScoreBox ScoreBox;
typedef struct _ScoreBoxClass ScoreBoxClass;
typedef struct _ScoreBoxPrivate ScoreBoxPrivate;

struct _ScoreBox {
	GtkHBox		 parent;
	PlayerColor	 color;
	ScoreBoxPrivate	*priv;
};

struct _ScoreBoxClass {
	GtkHBoxClass	 parent_class;
};

GType		 scorebox_get_type(void);
GtkWidget	*scorebox_new(PlayerColor color);

void		 scorebox_set_score(ScoreBox *sb, gint score);

#endif

